#pragma once

/** @cond hides from doxygen generation */
/* ----------------------- portability and cross-compatibility general defines ----------------------- */
#ifdef __cplusplus
#define _LLSYMBOLS_EXTERNC extern "C"
#else
#define _LLSYMBOLS_EXTERNC extern
#endif

#if defined (WIN32) || defined (WINCE) || defined(UNDER_RTSS) || defined(INTIME_EXECCORE)

	#ifndef LLSYMBOLS_STATIC
		#ifdef LLSYMBOLS_EXPORTS
			#define _LLSYMBOLS_DECLSPEC __declspec(dllexport)
		#else
			#define _LLSYMBOLS_DECLSPEC __declspec(dllimport)
		#endif

		/* define stdcall calling convention to be used with VB6 and VB.Net clients (only for .DLL, not static lib) */
		#define _LLSYMBOLS_CALLCONV __stdcall
	#else
		#define _LLSYMBOLS_DECLSPEC
		#define _LLSYMBOLS_CALLCONV
	#endif

	#if !defined(__INTIME__) && !defined(BIESSE_INTIME_EXECCORE)
		//Win32 standard
		#define WIN32_LEAN_AND_MEAN
		#include <windows.h>
		#include <tchar.h>
		#include <oleauto.h>
		#define _LLSYMBOLS_HAS_VARIANT

	#elif defined BIESSE_INTIME_EXECCORE
		// biesse, sia INtime realtime che win32 non-realtime
		#define WIN32_LEAN_AND_MEAN
		#include <windows.h>
		#include <tchar.h>
		// su INtime (anche se  cmq win32) non c' supporto ai VARIANT

	#elif defined INTIME_EXECCORE 
		//INtime nativo realtime
		#include <windows.h>
		#include <iwin32.h>
		#include <tchar.h>
		// su INtime (anche se  cmq win32) non c' supporto ai VARIANT
	#endif

#else
	/* no special declspec required and default calling convention*/
	#define _LLSYMBOLS_DECLSPEC
	#define _LLSYMBOLS_CALLCONV
	
	/* TCHAR is always char, no Unicode support */
    typedef char TCHAR;
	typedef const TCHAR * 	LPCTSTR;
	typedef const char 	* 	LPCSTR;
	typedef TCHAR 		* 	LPTSTR;
	typedef char 		* 	LPSTR;
	
	#define _T(s) s
	#define MAX_PATH 	260
#endif


#if defined(WIN32) && !defined( WINCE ) && !defined(_WIN64) && !defined(UNDER_RTSS) && !defined(__INTIME__)  && !defined(BIESSE_INTIME_EXECCORE)
// on windows platform (32bit only) WinCommlibs are also supported
	#define _LLSYMBOLS_HAS_WINCOMMLIBS
#endif

/* define standard API prototype, with LLSymResult return type */
#define LLSYMBOLS_API           _LLSYMBOLS_EXTERNC _LLSYMBOLS_DECLSPEC LLSymResult _LLSYMBOLS_CALLCONV
/* define standard API prototype with an alternative return type */
#define LLSYMBOLS_API_(retType) _LLSYMBOLS_EXTERNC _LLSYMBOLS_DECLSPEC retType     _LLSYMBOLS_CALLCONV

/** @endcond */
